> For the complete documentation index, see [llms.txt](https://developers.term.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.term.finance/0.5.31/term-repo-class/term-servicer-group/termrepolocker.md).

# TermRepoLocker.sol

## TermRepoLocker

This is the contract in which Term Servicer locks collateral and purchase tokens

*This contract belongs to the Term Servicer group of contracts and is specific to a Term Repo deployment*

### ADMIN\_ROLE

```solidity
bytes32 ADMIN_ROLE
```

### DEVOPS\_ROLE

```solidity
bytes32 DEVOPS_ROLE
```

### INITIALIZER\_ROLE

```solidity
bytes32 INITIALIZER_ROLE
```

### SERVICER\_ROLE

```solidity
bytes32 SERVICER_ROLE
```

### termRepoId

```solidity
bytes32 termRepoId
```

### transfersPaused

```solidity
bool transfersPaused
```

### emitter

```solidity
contract ITermEventEmitter emitter
```

### whileTransfersNotPaused

```solidity
modifier whileTransfersNotPaused()
```

### constructor

```solidity
constructor() public
```

### initialize

```solidity
function initialize(string termRepoId_, address termInitializer_) external
```

### pairTermContracts

```solidity
function pairTermContracts(address termRepoCollateralManager_, address termRepoServicer_, contract ITermEventEmitter emitter_, address devopsMultisig_, address adminWallet_) external
```

### transferTokenFromWallet

```solidity
function transferTokenFromWallet(address originWallet, address token, uint256 amount) external
```

Locks tokens from origin wallet Reverts if caller doesn't have SERVICER\_ROLE

#### Parameters

| Name         | Type    | Description                              |
| ------------ | ------- | ---------------------------------------- |
| originWallet | address | The wallet from which to transfer tokens |
| token        | address | The address of token being transferred   |
| amount       | uint256 | The amount of tokens to transfer         |

### transferTokenToWallet

```solidity
function transferTokenToWallet(address destinationWallet, address token, uint256 amount) external
```

Unlocks tokens to destination wallet

*Reverts if caller doesn't have SERVICER\_ROLE*

#### Parameters

| Name              | Type    | Description                         |
| ----------------- | ------- | ----------------------------------- |
| destinationWallet | address | The wallet to unlock tokens into    |
| token             | address | The address of token being unlocked |
| amount            | uint256 | The amount of tokens to unlock      |

### pauseTransfers

```solidity
function pauseTransfers() external
```

### unpauseTransfers

```solidity
function unpauseTransfers() external
```

### \_authorizeUpgrade

```solidity
function _authorizeUpgrade(address impl) internal
```

*required override by the OpenZeppelin UUPS module*

#### Parameters

| Name | Type    | Description                        |
| ---- | ------- | ---------------------------------- |
| impl | address | new impl address for proxy upgrade |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.term.finance/0.5.31/term-repo-class/term-servicer-group/termrepolocker.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
